<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>SQL分析</title>
    <script src="https://unpkg.com/axios/dist/axios.min.js"></script>
</head>
<body>
数据库ip:<input id="db_ip"/><br/>
数据库端口:<input id="db_port"/><br/>
数据库用户:<input id="db_username"/><br/>
数据库密码:<input id="db_password"/><br/>
数据库名称:<input id="db_schema"/><br/>

SQL分析:
<div>
    <textarea id="sql_analysis_id" onblur="analysis_sql(this)"
              style="width: 99vw;word-wrap:normal"></textarea>
    SQL分析结果:
    <div id="sql_analysis_result_id" style="width: 99vw;color:green;"></div>
    SQL语法检查结果:
    <div id="sql_check_result_id" style="width: 99vw;color:green;"></div>
    SQL格式化结果:
    <div id="sql_format_result_id" style="width: 99vw;color:green;"></div>
    SQL重写结果:
    <div id="sql_refactor_result_id" style="width: 99vw;color:green;"></div>
</div>

</body>
<script>
    const url_prefix = "http://" + window.location.host;

    /**
     * 编辑框的内容始终和其中的内容的高度保持一致
     * @param ele
     */
    function keep_edit_wh(ele) {
        const scroll_height = ele.scrollHeight;
        let height = ele.style.height;
        height = height.substring(0, height.length - 2);
        if (scroll_height - height > 5) {
            ele.style.height = (scroll_height + 0) + 'px';
        }
    }

    function get_sql(ele) {
        return ele.value;
    }

    function get_db_info() {
        const result = {};
        result.db_ip = document.getElementById('db_ip').value;
        result.db_port = document.getElementById('db_port').value;
        result.db_username = document.getElementById('db_username').value;
        result.db_password = document.getElementById('db_password').value;
        result.db_schema = document.getElementById('db_schema').value;
        return result;
    }

    function clear_page_result(result_ele_id) {
        document.getElementById(result_ele_id).innerHTML = '';
    }

    async function do_action(ele, action, result_ele_id) {
        keep_edit_wh(ele);
        const sql = get_sql(ele);
        clear_page_result(result_ele_id);
        if (!sql || sql.length < 1) return;
        const db_info = get_db_info();
        console.log(db_info);
        let data = await axios.post(url_prefix + "/soar", {
            original_sql: sql,
            action_command: action,
            db_info: db_info
        });
        console.log(data);
        if (!data || !data.data) return;
        document.getElementById(result_ele_id).innerHTML = data.data;
    }

    async function analysis_sql(ele) {
        await do_action(ele, 'analysis_sql', 'sql_analysis_result_id');
        await do_action(ele, 'check_sql', 'sql_check_result_id');
        await do_action(ele, 'format_sql', 'sql_format_result_id');
        await do_action(ele, 'refactor_sql', 'sql_refactor_result_id');
    }


</script>

</html>